#include <Firmata.h> // Pulls in the Firmata Library
//Commands reference look at
//http://arduino.cc/en/Reference/Firmata

byte potpin = 3; // pin to read pot  
int val; // value from the pot    

void setup() 
{ 
  Firmata.setFirmwareVersion(0, 1);
  Firmata.attach(ANALOG_MESSAGE, analogWriteCallback); // Attach a function to handle responses from flash.
  Firmata.begin();
} 

void loop()
{
  // If input coming from Flash then processInput
  while(Firmata.available()) {
    Firmata.processInput();// This is calling analogWriteCallback below.
  }
  //----------------------
  // Read the potentiometer and send to Flash
  val = analogRead(potpin);  // reads the value of the potentiometer (value between 0 and 1023) 
  Firmata.sendAnalog(potpin, val); //Send to Flash
  //----------------------
}

// Handles signals coming back from Flash. 
void analogWriteCallback(byte pin, int value) // flash using pin to tell
{
  pinMode(pin,OUTPUT);
  analogWrite(pin, value); // "Pin" comes in as 9 from Flash (set in flash)  
}
//-----------------------


